<template>
  <div class="article-comment-container">
    <vab-query-form>
      <vab-query-form-right-panel :span="24">
        <el-button icon="el-icon-refresh" type="primary" @click="queryData">
          {{ __('刷新') }}
        </el-button>
      </vab-query-form-right-panel>
    </vab-query-form>
    <el-table
      v-loading="listLoading"
      border
      :data="list"
      :height="tableConfig.height"
    >
      <el-table-column align="center" :label="__('操作')" width="120">
        <template #default="{ row }">
          <el-button type="text" @click="handleDelete(row)">
            {{ __('删除') }}
          </el-button>
        </template>
      </el-table-column>
      <el-table-column
        align="center"
        :label="__('评论编号')"
        prop="comment_id"
        show-overflow-tooltip
      />

      <el-table-column
        align="center"
        :label="__('文章编号')"
        prop="article_id"
        show-overflow-tooltip
      />

      <el-table-column
        align="center"
        :formatter="formatTime"
        :label="__('评论的日期和时间')"
        prop="comment_time"
        show-overflow-tooltip
      />
      <el-table-column
        align="center"
        :label="__('评论内容')"
        prop="comment_content"
        show-overflow-tooltip
      />

      <el-table-column
        align="center"
        :label="__('是否显示')"
        prop="comment_is_show"
      >
        <template slot-scope="scope">
          <el-switch
            v-model="scope.row.comment_is_show"

            :active-value="1"

            :inactive-value="0"
            @change="sChange(scope.row)"
          />
        </template>
      </el-table-column>
    </el-table>
    <el-pagination
      background
      :current-page="queryForm.pageNum"
      :layout="layout"
      :page-size="queryForm.pageSize"
      :total="total"
      @current-change="handleCurrentChange"
      @size-change="handleSizeChange"
    />
  </div>
</template>

<script>
  import { translateTitle as __ } from '@/utils/i18n'

  import { doDelete, doEdit, getList } from '@/api/article/comment'
  import { renderTime } from '@/utils/date'

  export default {
    name: 'ArticleComment',

    data() {
      return {
        tableConfig: {
          height: window.innerHeight - 220 - 90,
        },
        list: [],
        listLoading: true,
        layout: 'total, sizes, prev, pager, next, jumper',
        total: 0,
        selectRows: '',
        queryForm: {
          pageNum: 1,
          pageSize: 20,
          title: '',
        },
      }
    },
    created() {
      this.fetchData()
    },
    methods: {
      __,
      formatTime(row) {
        const cardTime = row.comment_time
        return cardTime ? renderTime(cardTime) : ''
      },
      formatShow(row) {
        return row.comment_is_show === 1 ? this.__('显示') : this.__('不显示')
      },
      handleDelete(row) {
        this.$baseConfirm(this.__('你确定要删除当前项吗'), null, async () => {
          const { msg } = await doDelete({ comment_id: row.comment_id })
          if (200 == status) {
            this.$baseMessage(msg, 'success')
          } else {
            this.$baseMessage(msg, 'error')
          }
          await this.fetchData()
        })
      },
      handleSizeChange(val) {
        this.queryForm.pageSize = val
        this.fetchData()
      },
      handleCurrentChange(val) {
        this.queryForm.pageNum = val
        this.fetchData()
      },
      queryData() {
        this.queryForm.pageNum = 1
        this.fetchData()
      },
      async sChange(row) {
        const param = {
          comment_id: row.comment_id,
          comment_is_show: row.comment_is_show,
        }
        const { msg } = await doEdit(param)
        this.$baseMessage(msg, 'success', false, 'vab-hey-message-success')
      },
      async fetchData() {
        this.listLoading = true
        const { data } = await getList(this.queryForm)
        this.list = data.items
        this.total = data.records
        this.listLoading = false
      },
    },
  }
</script>
